<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTGibUser ArrayType
 * @subpackage Arrays
 */
class ArrayOfTGibUser extends AbstractStructArrayBase
{
    /**
     * The TGibUser
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TGibUser[]
     */
    public $TGibUser;
    /**
     * Constructor method for ArrayOfTGibUser
     * @uses ArrayOfTGibUser::setTGibUser()
     * @param \StructType\TGibUser[] $tGibUser
     */
    public function __construct(array $tGibUser = array())
    {
        $this
            ->setTGibUser($tGibUser);
    }
    /**
     * Get TGibUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TGibUser[]|null
     */
    public function getTGibUser()
    {
        return isset($this->TGibUser) ? $this->TGibUser : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTGibUser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTGibUser method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTGibUserForArrayConstraintsFromSetTGibUser(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTGibUserTGibUserItem) {
            // validation for constraint: itemType
            if (!$arrayOfTGibUserTGibUserItem instanceof \StructType\TGibUser) {
                $invalidValues[] = is_object($arrayOfTGibUserTGibUserItem) ? get_class($arrayOfTGibUserTGibUserItem) : sprintf('%s(%s)', gettype($arrayOfTGibUserTGibUserItem), var_export($arrayOfTGibUserTGibUserItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TGibUser property can only contain items of type \StructType\TGibUser, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TGibUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TGibUser[] $tGibUser
     * @return \ArrayType\ArrayOfTGibUser
     */
    public function setTGibUser(array $tGibUser = array())
    {
        // validation for constraint: array
        if ('' !== ($tGibUserArrayErrorMessage = self::validateTGibUserForArrayConstraintsFromSetTGibUser($tGibUser))) {
            throw new \InvalidArgumentException($tGibUserArrayErrorMessage, __LINE__);
        }
        if (is_null($tGibUser) || (is_array($tGibUser) && empty($tGibUser))) {
            unset($this->TGibUser);
        } else {
            $this->TGibUser = $tGibUser;
        }
        return $this;
    }
    /**
     * Add item to TGibUser value
     * @throws \InvalidArgumentException
     * @param \StructType\TGibUser $item
     * @return \ArrayType\ArrayOfTGibUser
     */
    public function addToTGibUser(\StructType\TGibUser $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TGibUser) {
            throw new \InvalidArgumentException(sprintf('The TGibUser property can only contain items of type \StructType\TGibUser, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TGibUser[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TGibUser|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TGibUser|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TGibUser|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TGibUser|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TGibUser|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TGibUser
     */
    public function getAttributeName()
    {
        return 'TGibUser';
    }
}
