<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceIdentity ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceIdentity extends AbstractStructArrayBase
{
    /**
     * The TInvoiceIdentity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceIdentity[]
     */
    public $TInvoiceIdentity;
    /**
     * Constructor method for ArrayOfTInvoiceIdentity
     * @uses ArrayOfTInvoiceIdentity::setTInvoiceIdentity()
     * @param \StructType\TInvoiceIdentity[] $tInvoiceIdentity
     */
    public function __construct(array $tInvoiceIdentity = array())
    {
        $this
            ->setTInvoiceIdentity($tInvoiceIdentity);
    }
    /**
     * Get TInvoiceIdentity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceIdentity[]|null
     */
    public function getTInvoiceIdentity()
    {
        return isset($this->TInvoiceIdentity) ? $this->TInvoiceIdentity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceIdentity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceIdentity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceIdentityForArrayConstraintsFromSetTInvoiceIdentity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceIdentityTInvoiceIdentityItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceIdentityTInvoiceIdentityItem instanceof \StructType\TInvoiceIdentity) {
                $invalidValues[] = is_object($arrayOfTInvoiceIdentityTInvoiceIdentityItem) ? get_class($arrayOfTInvoiceIdentityTInvoiceIdentityItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceIdentityTInvoiceIdentityItem), var_export($arrayOfTInvoiceIdentityTInvoiceIdentityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceIdentity property can only contain items of type \StructType\TInvoiceIdentity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceIdentity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceIdentity[] $tInvoiceIdentity
     * @return \ArrayType\ArrayOfTInvoiceIdentity
     */
    public function setTInvoiceIdentity(array $tInvoiceIdentity = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceIdentityArrayErrorMessage = self::validateTInvoiceIdentityForArrayConstraintsFromSetTInvoiceIdentity($tInvoiceIdentity))) {
            throw new \InvalidArgumentException($tInvoiceIdentityArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceIdentity) || (is_array($tInvoiceIdentity) && empty($tInvoiceIdentity))) {
            unset($this->TInvoiceIdentity);
        } else {
            $this->TInvoiceIdentity = $tInvoiceIdentity;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceIdentity value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceIdentity $item
     * @return \ArrayType\ArrayOfTInvoiceIdentity
     */
    public function addToTInvoiceIdentity(\StructType\TInvoiceIdentity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceIdentity) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceIdentity property can only contain items of type \StructType\TInvoiceIdentity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceIdentity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceIdentity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceIdentity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceIdentity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceIdentity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceIdentity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceIdentity
     */
    public function getAttributeName()
    {
        return 'TInvoiceIdentity';
    }
}
