<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceInfo extends AbstractStructArrayBase
{
    /**
     * The TInvoiceInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceInfo[]
     */
    public $TInvoiceInfo;
    /**
     * Constructor method for ArrayOfTInvoiceInfo
     * @uses ArrayOfTInvoiceInfo::setTInvoiceInfo()
     * @param \StructType\TInvoiceInfo[] $tInvoiceInfo
     */
    public function __construct(array $tInvoiceInfo = array())
    {
        $this
            ->setTInvoiceInfo($tInvoiceInfo);
    }
    /**
     * Get TInvoiceInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceInfo[]|null
     */
    public function getTInvoiceInfo()
    {
        return isset($this->TInvoiceInfo) ? $this->TInvoiceInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceInfoForArrayConstraintsFromSetTInvoiceInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceInfoTInvoiceInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceInfoTInvoiceInfoItem instanceof \StructType\TInvoiceInfo) {
                $invalidValues[] = is_object($arrayOfTInvoiceInfoTInvoiceInfoItem) ? get_class($arrayOfTInvoiceInfoTInvoiceInfoItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceInfoTInvoiceInfoItem), var_export($arrayOfTInvoiceInfoTInvoiceInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceInfo property can only contain items of type \StructType\TInvoiceInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceInfo[] $tInvoiceInfo
     * @return \ArrayType\ArrayOfTInvoiceInfo
     */
    public function setTInvoiceInfo(array $tInvoiceInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceInfoArrayErrorMessage = self::validateTInvoiceInfoForArrayConstraintsFromSetTInvoiceInfo($tInvoiceInfo))) {
            throw new \InvalidArgumentException($tInvoiceInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceInfo) || (is_array($tInvoiceInfo) && empty($tInvoiceInfo))) {
            unset($this->TInvoiceInfo);
        } else {
            $this->TInvoiceInfo = $tInvoiceInfo;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceInfo $item
     * @return \ArrayType\ArrayOfTInvoiceInfo
     */
    public function addToTInvoiceInfo(\StructType\TInvoiceInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceInfo) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceInfo property can only contain items of type \StructType\TInvoiceInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceInfo
     */
    public function getAttributeName()
    {
        return 'TInvoiceInfo';
    }
}
