<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceLine ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceLine extends AbstractStructArrayBase
{
    /**
     * The TInvoiceLine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceLine[]
     */
    public $TInvoiceLine;
    /**
     * Constructor method for ArrayOfTInvoiceLine
     * @uses ArrayOfTInvoiceLine::setTInvoiceLine()
     * @param \StructType\TInvoiceLine[] $tInvoiceLine
     */
    public function __construct(array $tInvoiceLine = array())
    {
        $this
            ->setTInvoiceLine($tInvoiceLine);
    }
    /**
     * Get TInvoiceLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceLine[]|null
     */
    public function getTInvoiceLine()
    {
        return isset($this->TInvoiceLine) ? $this->TInvoiceLine : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceLineForArrayConstraintsFromSetTInvoiceLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceLineTInvoiceLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceLineTInvoiceLineItem instanceof \StructType\TInvoiceLine) {
                $invalidValues[] = is_object($arrayOfTInvoiceLineTInvoiceLineItem) ? get_class($arrayOfTInvoiceLineTInvoiceLineItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceLineTInvoiceLineItem), var_export($arrayOfTInvoiceLineTInvoiceLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceLine property can only contain items of type \StructType\TInvoiceLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceLine[] $tInvoiceLine
     * @return \ArrayType\ArrayOfTInvoiceLine
     */
    public function setTInvoiceLine(array $tInvoiceLine = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceLineArrayErrorMessage = self::validateTInvoiceLineForArrayConstraintsFromSetTInvoiceLine($tInvoiceLine))) {
            throw new \InvalidArgumentException($tInvoiceLineArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceLine) || (is_array($tInvoiceLine) && empty($tInvoiceLine))) {
            unset($this->TInvoiceLine);
        } else {
            $this->TInvoiceLine = $tInvoiceLine;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceLine value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceLine $item
     * @return \ArrayType\ArrayOfTInvoiceLine
     */
    public function addToTInvoiceLine(\StructType\TInvoiceLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceLine) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceLine property can only contain items of type \StructType\TInvoiceLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceLine
     */
    public function getAttributeName()
    {
        return 'TInvoiceLine';
    }
}
