<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceResponse extends AbstractStructArrayBase
{
    /**
     * The TInvoiceResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceResponse[]
     */
    public $TInvoiceResponse;
    /**
     * Constructor method for ArrayOfTInvoiceResponse
     * @uses ArrayOfTInvoiceResponse::setTInvoiceResponse()
     * @param \StructType\TInvoiceResponse[] $tInvoiceResponse
     */
    public function __construct(array $tInvoiceResponse = array())
    {
        $this
            ->setTInvoiceResponse($tInvoiceResponse);
    }
    /**
     * Get TInvoiceResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceResponse[]|null
     */
    public function getTInvoiceResponse()
    {
        return isset($this->TInvoiceResponse) ? $this->TInvoiceResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceResponseForArrayConstraintsFromSetTInvoiceResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceResponseTInvoiceResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceResponseTInvoiceResponseItem instanceof \StructType\TInvoiceResponse) {
                $invalidValues[] = is_object($arrayOfTInvoiceResponseTInvoiceResponseItem) ? get_class($arrayOfTInvoiceResponseTInvoiceResponseItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceResponseTInvoiceResponseItem), var_export($arrayOfTInvoiceResponseTInvoiceResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceResponse property can only contain items of type \StructType\TInvoiceResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceResponse[] $tInvoiceResponse
     * @return \ArrayType\ArrayOfTInvoiceResponse
     */
    public function setTInvoiceResponse(array $tInvoiceResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceResponseArrayErrorMessage = self::validateTInvoiceResponseForArrayConstraintsFromSetTInvoiceResponse($tInvoiceResponse))) {
            throw new \InvalidArgumentException($tInvoiceResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceResponse) || (is_array($tInvoiceResponse) && empty($tInvoiceResponse))) {
            unset($this->TInvoiceResponse);
        } else {
            $this->TInvoiceResponse = $tInvoiceResponse;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceResponse $item
     * @return \ArrayType\ArrayOfTInvoiceResponse
     */
    public function addToTInvoiceResponse(\StructType\TInvoiceResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceResponse) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceResponse property can only contain items of type \StructType\TInvoiceResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceResponse
     */
    public function getAttributeName()
    {
        return 'TInvoiceResponse';
    }
}
