<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceStatus ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceStatus extends AbstractStructArrayBase
{
    /**
     * The TInvoiceStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceStatus[]
     */
    public $TInvoiceStatus;
    /**
     * Constructor method for ArrayOfTInvoiceStatus
     * @uses ArrayOfTInvoiceStatus::setTInvoiceStatus()
     * @param \StructType\TInvoiceStatus[] $tInvoiceStatus
     */
    public function __construct(array $tInvoiceStatus = array())
    {
        $this
            ->setTInvoiceStatus($tInvoiceStatus);
    }
    /**
     * Get TInvoiceStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceStatus[]|null
     */
    public function getTInvoiceStatus()
    {
        return isset($this->TInvoiceStatus) ? $this->TInvoiceStatus : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceStatusForArrayConstraintsFromSetTInvoiceStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceStatusTInvoiceStatusItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceStatusTInvoiceStatusItem instanceof \StructType\TInvoiceStatus) {
                $invalidValues[] = is_object($arrayOfTInvoiceStatusTInvoiceStatusItem) ? get_class($arrayOfTInvoiceStatusTInvoiceStatusItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceStatusTInvoiceStatusItem), var_export($arrayOfTInvoiceStatusTInvoiceStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceStatus property can only contain items of type \StructType\TInvoiceStatus, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceStatus[] $tInvoiceStatus
     * @return \ArrayType\ArrayOfTInvoiceStatus
     */
    public function setTInvoiceStatus(array $tInvoiceStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceStatusArrayErrorMessage = self::validateTInvoiceStatusForArrayConstraintsFromSetTInvoiceStatus($tInvoiceStatus))) {
            throw new \InvalidArgumentException($tInvoiceStatusArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceStatus) || (is_array($tInvoiceStatus) && empty($tInvoiceStatus))) {
            unset($this->TInvoiceStatus);
        } else {
            $this->TInvoiceStatus = $tInvoiceStatus;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceStatus value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceStatus $item
     * @return \ArrayType\ArrayOfTInvoiceStatus
     */
    public function addToTInvoiceStatus(\StructType\TInvoiceStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceStatus) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceStatus property can only contain items of type \StructType\TInvoiceStatus, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceStatus[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceStatus|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceStatus|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceStatus|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceStatus|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceStatus|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceStatus
     */
    public function getAttributeName()
    {
        return 'TInvoiceStatus';
    }
}
