<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTInvoiceStatusModel ArrayType
 * @subpackage Arrays
 */
class ArrayOfTInvoiceStatusModel extends AbstractStructArrayBase
{
    /**
     * The TInvoiceStatusModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TInvoiceStatusModel[]
     */
    public $TInvoiceStatusModel;
    /**
     * Constructor method for ArrayOfTInvoiceStatusModel
     * @uses ArrayOfTInvoiceStatusModel::setTInvoiceStatusModel()
     * @param \StructType\TInvoiceStatusModel[] $tInvoiceStatusModel
     */
    public function __construct(array $tInvoiceStatusModel = array())
    {
        $this
            ->setTInvoiceStatusModel($tInvoiceStatusModel);
    }
    /**
     * Get TInvoiceStatusModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TInvoiceStatusModel[]|null
     */
    public function getTInvoiceStatusModel()
    {
        return isset($this->TInvoiceStatusModel) ? $this->TInvoiceStatusModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTInvoiceStatusModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTInvoiceStatusModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTInvoiceStatusModelForArrayConstraintsFromSetTInvoiceStatusModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTInvoiceStatusModelTInvoiceStatusModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfTInvoiceStatusModelTInvoiceStatusModelItem instanceof \StructType\TInvoiceStatusModel) {
                $invalidValues[] = is_object($arrayOfTInvoiceStatusModelTInvoiceStatusModelItem) ? get_class($arrayOfTInvoiceStatusModelTInvoiceStatusModelItem) : sprintf('%s(%s)', gettype($arrayOfTInvoiceStatusModelTInvoiceStatusModelItem), var_export($arrayOfTInvoiceStatusModelTInvoiceStatusModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TInvoiceStatusModel property can only contain items of type \StructType\TInvoiceStatusModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TInvoiceStatusModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceStatusModel[] $tInvoiceStatusModel
     * @return \ArrayType\ArrayOfTInvoiceStatusModel
     */
    public function setTInvoiceStatusModel(array $tInvoiceStatusModel = array())
    {
        // validation for constraint: array
        if ('' !== ($tInvoiceStatusModelArrayErrorMessage = self::validateTInvoiceStatusModelForArrayConstraintsFromSetTInvoiceStatusModel($tInvoiceStatusModel))) {
            throw new \InvalidArgumentException($tInvoiceStatusModelArrayErrorMessage, __LINE__);
        }
        if (is_null($tInvoiceStatusModel) || (is_array($tInvoiceStatusModel) && empty($tInvoiceStatusModel))) {
            unset($this->TInvoiceStatusModel);
        } else {
            $this->TInvoiceStatusModel = $tInvoiceStatusModel;
        }
        return $this;
    }
    /**
     * Add item to TInvoiceStatusModel value
     * @throws \InvalidArgumentException
     * @param \StructType\TInvoiceStatusModel $item
     * @return \ArrayType\ArrayOfTInvoiceStatusModel
     */
    public function addToTInvoiceStatusModel(\StructType\TInvoiceStatusModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TInvoiceStatusModel) {
            throw new \InvalidArgumentException(sprintf('The TInvoiceStatusModel property can only contain items of type \StructType\TInvoiceStatusModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TInvoiceStatusModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TInvoiceStatusModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TInvoiceStatusModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TInvoiceStatusModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TInvoiceStatusModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TInvoiceStatusModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TInvoiceStatusModel
     */
    public function getAttributeName()
    {
        return 'TInvoiceStatusModel';
    }
}
