<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTPaymentMeans ArrayType
 * @subpackage Arrays
 */
class ArrayOfTPaymentMeans extends AbstractStructArrayBase
{
    /**
     * The TPaymentMeans
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TPaymentMeans[]
     */
    public $TPaymentMeans;
    /**
     * Constructor method for ArrayOfTPaymentMeans
     * @uses ArrayOfTPaymentMeans::setTPaymentMeans()
     * @param \StructType\TPaymentMeans[] $tPaymentMeans
     */
    public function __construct(array $tPaymentMeans = array())
    {
        $this
            ->setTPaymentMeans($tPaymentMeans);
    }
    /**
     * Get TPaymentMeans value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TPaymentMeans[]|null
     */
    public function getTPaymentMeans()
    {
        return isset($this->TPaymentMeans) ? $this->TPaymentMeans : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTPaymentMeans method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTPaymentMeans method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTPaymentMeansForArrayConstraintsFromSetTPaymentMeans(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTPaymentMeansTPaymentMeansItem) {
            // validation for constraint: itemType
            if (!$arrayOfTPaymentMeansTPaymentMeansItem instanceof \StructType\TPaymentMeans) {
                $invalidValues[] = is_object($arrayOfTPaymentMeansTPaymentMeansItem) ? get_class($arrayOfTPaymentMeansTPaymentMeansItem) : sprintf('%s(%s)', gettype($arrayOfTPaymentMeansTPaymentMeansItem), var_export($arrayOfTPaymentMeansTPaymentMeansItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TPaymentMeans property can only contain items of type \StructType\TPaymentMeans, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TPaymentMeans value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TPaymentMeans[] $tPaymentMeans
     * @return \ArrayType\ArrayOfTPaymentMeans
     */
    public function setTPaymentMeans(array $tPaymentMeans = array())
    {
        // validation for constraint: array
        if ('' !== ($tPaymentMeansArrayErrorMessage = self::validateTPaymentMeansForArrayConstraintsFromSetTPaymentMeans($tPaymentMeans))) {
            throw new \InvalidArgumentException($tPaymentMeansArrayErrorMessage, __LINE__);
        }
        if (is_null($tPaymentMeans) || (is_array($tPaymentMeans) && empty($tPaymentMeans))) {
            unset($this->TPaymentMeans);
        } else {
            $this->TPaymentMeans = $tPaymentMeans;
        }
        return $this;
    }
    /**
     * Add item to TPaymentMeans value
     * @throws \InvalidArgumentException
     * @param \StructType\TPaymentMeans $item
     * @return \ArrayType\ArrayOfTPaymentMeans
     */
    public function addToTPaymentMeans(\StructType\TPaymentMeans $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TPaymentMeans) {
            throw new \InvalidArgumentException(sprintf('The TPaymentMeans property can only contain items of type \StructType\TPaymentMeans, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TPaymentMeans[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TPaymentMeans|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TPaymentMeans|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TPaymentMeans|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TPaymentMeans|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TPaymentMeans|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TPaymentMeans
     */
    public function getAttributeName()
    {
        return 'TPaymentMeans';
    }
}
