<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'VersionInfo' => '\\StructType\\VersionInfo',
            'VersionInfoResponse' => '\\StructType\\VersionInfoResponse',
            'CheckLicense' => '\\StructType\\CheckLicense',
            'TLoginInfo' => '\\StructType\\TLoginInfo',
            'CheckLicenseResponse' => '\\StructType\\CheckLicenseResponse',
            'TReturnTypeOfSubscription' => '\\StructType\\TReturnTypeOfSubscription',
            'Subscription' => '\\StructType\\Subscription',
            'TReturnStatus' => '\\StructType\\TReturnStatus',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'DumpInvoice' => '\\StructType\\DumpInvoice',
            'TInvoiceInfo' => '\\StructType\\TInvoiceInfo',
            'TInvoice' => '\\StructType\\TInvoice',
            'TParty' => '\\StructType\\TParty',
            'ArrayOfTInvoiceLine' => '\\ArrayType\\ArrayOfTInvoiceLine',
            'TInvoiceLine' => '\\StructType\\TInvoiceLine',
            'ArrayOfTTaxTotal' => '\\ArrayType\\ArrayOfTTaxTotal',
            'TTaxTotal' => '\\StructType\\TTaxTotal',
            'TDeliveryType' => '\\StructType\\TDeliveryType',
            'TDeliveryAddressType' => '\\StructType\\TDeliveryAddressType',
            'ArrayOfTPaymentMeans' => '\\ArrayType\\ArrayOfTPaymentMeans',
            'TPaymentMeans' => '\\StructType\\TPaymentMeans',
            'TSgkInvoiceInfo' => '\\StructType\\TSgkInvoiceInfo',
            'TBillingReference' => '\\StructType\\TBillingReference',
            'TTargetCustomer' => '\\StructType\\TTargetCustomer',
            'TEArchiveInvoiceInfo' => '\\StructType\\TEArchiveInvoiceInfo',
            'DumpInvoiceResponse' => '\\StructType\\DumpInvoiceResponse',
            'DumpGibUsers' => '\\StructType\\DumpGibUsers',
            'ArrayOfTGibUser' => '\\ArrayType\\ArrayOfTGibUser',
            'TGibUser' => '\\StructType\\TGibUser',
            'DumpGibUsersResponse' => '\\StructType\\DumpGibUsersResponse',
            'SendInvoice' => '\\StructType\\SendInvoice',
            'ArrayOfTInvoiceInfo' => '\\ArrayType\\ArrayOfTInvoiceInfo',
            'SendInvoiceResponse' => '\\StructType\\SendInvoiceResponse',
            'TReturnTypeOfListOfTInvoiceIdentity' => '\\StructType\\TReturnTypeOfListOfTInvoiceIdentity',
            'ArrayOfTInvoiceIdentity' => '\\ArrayType\\ArrayOfTInvoiceIdentity',
            'TInvoiceIdentity' => '\\StructType\\TInvoiceIdentity',
            'SendDraftInvoice' => '\\StructType\\SendDraftInvoice',
            'SendDraftInvoiceResponse' => '\\StructType\\SendDraftInvoiceResponse',
            'SendInvoiceStatus' => '\\StructType\\SendInvoiceStatus',
            'SendInvoiceStatusResponse' => '\\StructType\\SendInvoiceStatusResponse',
            'TReturnTypeOfBoolean' => '\\StructType\\TReturnTypeOfBoolean',
            'CheckUser' => '\\StructType\\CheckUser',
            'CheckUserResponse' => '\\StructType\\CheckUserResponse',
            'TReturnTypeOfListOfTGibUser' => '\\StructType\\TReturnTypeOfListOfTGibUser',
            'GetInvoiceStatus' => '\\StructType\\GetInvoiceStatus',
            'TInvoiceStatusRequest' => '\\StructType\\TInvoiceStatusRequest',
            'ArrayOfTInvoiceStatusModel' => '\\ArrayType\\ArrayOfTInvoiceStatusModel',
            'TInvoiceStatusModel' => '\\StructType\\TInvoiceStatusModel',
            'GetInvoiceStatusResponse' => '\\StructType\\GetInvoiceStatusResponse',
            'TReturnTypeOfListOfTInvoiceStatus' => '\\StructType\\TReturnTypeOfListOfTInvoiceStatus',
            'ArrayOfTInvoiceStatus' => '\\ArrayType\\ArrayOfTInvoiceStatus',
            'TInvoiceStatus' => '\\StructType\\TInvoiceStatus',
            'GetInboxInvoiceStatus' => '\\StructType\\GetInboxInvoiceStatus',
            'GetInboxInvoiceStatusResponse' => '\\StructType\\GetInboxInvoiceStatusResponse',
            'GetTestInvoiceStatus' => '\\StructType\\GetTestInvoiceStatus',
            'GetTestInvoiceStatusResponse' => '\\StructType\\GetTestInvoiceStatusResponse',
            'GetInboxInvoices' => '\\StructType\\GetInboxInvoices',
            'TInboxInvoiceQueryModel' => '\\StructType\\TInboxInvoiceQueryModel',
            'GetInboxInvoicesResponse' => '\\StructType\\GetInboxInvoicesResponse',
            'TReturnTypeOfListOfTInvoiceResponse' => '\\StructType\\TReturnTypeOfListOfTInvoiceResponse',
            'ArrayOfTInvoiceResponse' => '\\ArrayType\\ArrayOfTInvoiceResponse',
            'TInvoiceResponse' => '\\StructType\\TInvoiceResponse',
            'GetTestInboxInvoices' => '\\StructType\\GetTestInboxInvoices',
            'GetTestInboxInvoicesResponse' => '\\StructType\\GetTestInboxInvoicesResponse',
            'GetInboxInvoice' => '\\StructType\\GetInboxInvoice',
            'GetInboxInvoiceResponse' => '\\StructType\\GetInboxInvoiceResponse',
            'TReturnTypeOfTInvoiceInfo' => '\\StructType\\TReturnTypeOfTInvoiceInfo',
            'GetWebKey' => '\\StructType\\GetWebKey',
            'GetWebKeyResponse' => '\\StructType\\GetWebKeyResponse',
            'GetInvoice' => '\\StructType\\GetInvoice',
            'GetInvoiceResponse' => '\\StructType\\GetInvoiceResponse',
            'GetTestInvoice' => '\\StructType\\GetTestInvoice',
            'GetTestInvoiceResponse' => '\\StructType\\GetTestInvoiceResponse',
            'SandboxInvoice' => '\\StructType\\SandboxInvoice',
            'SandboxInvoiceResponse' => '\\StructType\\SandboxInvoiceResponse',
            'TestInvoiceStatus' => '\\StructType\\TestInvoiceStatus',
            'TestInvoiceStatusResponse' => '\\StructType\\TestInvoiceStatusResponse',
            'CheckUserList' => '\\StructType\\CheckUserList',
            'CheckUserListResponse' => '\\StructType\\CheckUserListResponse',
            'CheckUserListAsync' => '\\StructType\\CheckUserListAsync',
            'CheckUserListAsyncResponse' => '\\StructType\\CheckUserListAsyncResponse',
            'TaskOfTReturnTypeOfListOfTGibUser' => '\\StructType\\TaskOfTReturnTypeOfListOfTGibUser',
            'Task' => '\\StructType\\Task',
        );
    }
}
