<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DumpGibUsers StructType
 * @subpackage Structs
 */
class DumpGibUsers extends AbstractStructBase
{
    /**
     * The dataType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $dataType;
    /**
     * The gibUsers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTGibUser
     */
    public $gibUsers;
    /**
     * Constructor method for DumpGibUsers
     * @uses DumpGibUsers::setDataType()
     * @uses DumpGibUsers::setGibUsers()
     * @param string $dataType
     * @param \ArrayType\ArrayOfTGibUser $gibUsers
     */
    public function __construct($dataType = null, \ArrayType\ArrayOfTGibUser $gibUsers = null)
    {
        $this
            ->setDataType($dataType)
            ->setGibUsers($gibUsers);
    }
    /**
     * Get dataType value
     * @return string
     */
    public function getDataType()
    {
        return $this->dataType;
    }
    /**
     * Set dataType value
     * @uses \EnumType\DataType::valueIsValid()
     * @uses \EnumType\DataType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $dataType
     * @return \StructType\DumpGibUsers
     */
    public function setDataType($dataType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DataType::valueIsValid($dataType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DataType', is_array($dataType) ? implode(', ', $dataType) : var_export($dataType, true), implode(', ', \EnumType\DataType::getValidValues())), __LINE__);
        }
        $this->dataType = $dataType;
        return $this;
    }
    /**
     * Get gibUsers value
     * @return \ArrayType\ArrayOfTGibUser|null
     */
    public function getGibUsers()
    {
        return $this->gibUsers;
    }
    /**
     * Set gibUsers value
     * @param \ArrayType\ArrayOfTGibUser $gibUsers
     * @return \StructType\DumpGibUsers
     */
    public function setGibUsers(\ArrayType\ArrayOfTGibUser $gibUsers = null)
    {
        $this->gibUsers = $gibUsers;
        return $this;
    }
}
