<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetWebKey StructType
 * @subpackage Structs
 */
class GetWebKey extends AbstractStructBase
{
    /**
     * The loginInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TLoginInfo
     */
    public $loginInfo;
    /**
     * The UUID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UUID;
    /**
     * Constructor method for GetWebKey
     * @uses GetWebKey::setLoginInfo()
     * @uses GetWebKey::setUUID()
     * @param \StructType\TLoginInfo $loginInfo
     * @param string $uUID
     */
    public function __construct(\StructType\TLoginInfo $loginInfo = null, $uUID = null)
    {
        $this
            ->setLoginInfo($loginInfo)
            ->setUUID($uUID);
    }
    /**
     * Get loginInfo value
     * @return \StructType\TLoginInfo|null
     */
    public function getLoginInfo()
    {
        return $this->loginInfo;
    }
    /**
     * Set loginInfo value
     * @param \StructType\TLoginInfo $loginInfo
     * @return \StructType\GetWebKey
     */
    public function setLoginInfo(\StructType\TLoginInfo $loginInfo = null)
    {
        $this->loginInfo = $loginInfo;
        return $this;
    }
    /**
     * Get UUID value
     * @return string|null
     */
    public function getUUID()
    {
        return $this->UUID;
    }
    /**
     * Set UUID value
     * @param string $uUID
     * @return \StructType\GetWebKey
     */
    public function setUUID($uUID = null)
    {
        // validation for constraint: string
        if (!is_null($uUID) && !is_string($uUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uUID, true), gettype($uUID)), __LINE__);
        }
        $this->UUID = $uUID;
        return $this;
    }
}
