<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendInvoice StructType
 * @subpackage Structs
 */
class SendInvoice extends AbstractStructBase
{
    /**
     * The loginInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TLoginInfo
     */
    public $loginInfo;
    /**
     * The invoiceInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTInvoiceInfo
     */
    public $invoiceInfo;
    /**
     * Constructor method for SendInvoice
     * @uses SendInvoice::setLoginInfo()
     * @uses SendInvoice::setInvoiceInfo()
     * @param \StructType\TLoginInfo $loginInfo
     * @param \ArrayType\ArrayOfTInvoiceInfo $invoiceInfo
     */
    public function __construct(\StructType\TLoginInfo $loginInfo = null, \ArrayType\ArrayOfTInvoiceInfo $invoiceInfo = null)
    {
        $this
            ->setLoginInfo($loginInfo)
            ->setInvoiceInfo($invoiceInfo);
    }
    /**
     * Get loginInfo value
     * @return \StructType\TLoginInfo|null
     */
    public function getLoginInfo()
    {
        return $this->loginInfo;
    }
    /**
     * Set loginInfo value
     * @param \StructType\TLoginInfo $loginInfo
     * @return \StructType\SendInvoice
     */
    public function setLoginInfo(\StructType\TLoginInfo $loginInfo = null)
    {
        $this->loginInfo = $loginInfo;
        return $this;
    }
    /**
     * Get invoiceInfo value
     * @return \ArrayType\ArrayOfTInvoiceInfo|null
     */
    public function getInvoiceInfo()
    {
        return $this->invoiceInfo;
    }
    /**
     * Set invoiceInfo value
     * @param \ArrayType\ArrayOfTInvoiceInfo $invoiceInfo
     * @return \StructType\SendInvoice
     */
    public function setInvoiceInfo(\ArrayType\ArrayOfTInvoiceInfo $invoiceInfo = null)
    {
        $this->invoiceInfo = $invoiceInfo;
        return $this;
    }
}
