<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TTargetCustomer StructType
 * @subpackage Structs
 */
class TTargetCustomer extends AbstractStructBase
{
    /**
     * The DefaultAlias
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $DefaultAlias;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Title;
    /**
     * The VknTckn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VknTckn;
    /**
     * The Alias
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Alias;
    /**
     * Constructor method for TTargetCustomer
     * @uses TTargetCustomer::setDefaultAlias()
     * @uses TTargetCustomer::setTitle()
     * @uses TTargetCustomer::setVknTckn()
     * @uses TTargetCustomer::setAlias()
     * @param bool $defaultAlias
     * @param string $title
     * @param string $vknTckn
     * @param string $alias
     */
    public function __construct($defaultAlias = null, $title = null, $vknTckn = null, $alias = null)
    {
        $this
            ->setDefaultAlias($defaultAlias)
            ->setTitle($title)
            ->setVknTckn($vknTckn)
            ->setAlias($alias);
    }
    /**
     * Get DefaultAlias value
     * @return bool
     */
    public function getDefaultAlias()
    {
        return $this->DefaultAlias;
    }
    /**
     * Set DefaultAlias value
     * @param bool $defaultAlias
     * @return \StructType\TTargetCustomer
     */
    public function setDefaultAlias($defaultAlias = null)
    {
        // validation for constraint: boolean
        if (!is_null($defaultAlias) && !is_bool($defaultAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($defaultAlias, true), gettype($defaultAlias)), __LINE__);
        }
        $this->DefaultAlias = $defaultAlias;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \StructType\TTargetCustomer
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get VknTckn value
     * @return string|null
     */
    public function getVknTckn()
    {
        return $this->VknTckn;
    }
    /**
     * Set VknTckn value
     * @param string $vknTckn
     * @return \StructType\TTargetCustomer
     */
    public function setVknTckn($vknTckn = null)
    {
        // validation for constraint: string
        if (!is_null($vknTckn) && !is_string($vknTckn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vknTckn, true), gettype($vknTckn)), __LINE__);
        }
        $this->VknTckn = $vknTckn;
        return $this;
    }
    /**
     * Get Alias value
     * @return string|null
     */
    public function getAlias()
    {
        return $this->Alias;
    }
    /**
     * Set Alias value
     * @param string $alias
     * @return \StructType\TTargetCustomer
     */
    public function setAlias($alias = null)
    {
        // validation for constraint: string
        if (!is_null($alias) && !is_string($alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alias, true), gettype($alias)), __LINE__);
        }
        $this->Alias = $alias;
        return $this;
    }
}
